VERSION 4.00
Begin VB.Form enumerate 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Enumerate COM Ports"
   ClientHeight    =   1050
   ClientLeft      =   6195
   ClientTop       =   3120
   ClientWidth     =   3735
   Height          =   1740
   Left            =   6135
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1050
   ScaleWidth      =   3735
   ShowInTaskbar   =   0   'False
   Top             =   2490
   Width           =   3855
   Begin VB.TextBox Text1 
      Height          =   975
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   0
      Width           =   3495
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   480
      Top             =   120
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.Menu mnuPort 
      Caption         =   "&Port"
      Begin VB.Menu mnuCOMPort 
         Caption         =   "none"
         Index           =   0
      End
   End
End
Attribute VB_Name = "enumerate"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

Option Explicit

Private Type PORT_INFO_2
  pPortName As String
  pMonitorName As String
  pDescription As String
  fPortType As Long
  Reserved As Long
End Type
Private comPorts(0 To 100) As PORT_INFO_2

Private Type API_PORT_INFO_2
  pPortName As Long
  pMonitorName As Long
  pDescription As Long
  fPortType As Long
  Reserved As Long
End Type

Const MF_BYCOMMAND = &H0
Const SC_SIZE = &HF000

Dim loading               As Boolean
Dim cntports              As Integer
Dim mlngCountCOMPorts     As Long

Private Declare Function EnumPorts Lib "winspool.drv" Alias "EnumPortsA" (ByVal pName As String, ByVal Level As Long, ByVal lpbPorts As Long, ByVal cbBuf As Long, pcbNeeded As Long, pcReturned As Long) As Long
Private Declare Function lstrlenW Lib "kernel32.dll" (ByVal lpString As Long) As Long
Private Declare Function HeapAlloc Lib "kernel32.dll" (ByVal hHeap As Long, ByVal dwFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GetProcessHeap Lib "kernel32.dll" () As Long
Private Declare Function GetSystemMenu Lib "user32" (ByVal hwnd As Long, ByVal bRevert As Long) As Long
Private Declare Function HeapFree Lib "kernel32.dll" (ByVal hHeap As Long, ByVal dwFlags As Long, lpMem As Any) As Long
Private Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long
Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, src As Any, ByVal numbytes As Long)

Public Function Exist(fname As String) As Boolean

  Dim result As Long

  On Error Resume Next
  result = FileLen(fname)

  If Err = 0 Then Exist = True
  
End Function

Private Sub Form_Load()
  
  Dim i            As Integer
  Dim n            As Integer
  Dim numPorts     As Long
  Dim nports       As Integer
  Dim strPorts     As String
  Dim temp         As String
  Dim cports()     As String
  Dim hSysMenu     As Long
  
  loading = True

  hSysMenu = GetSystemMenu(hwnd, 0)
  RemoveMenu hSysMenu, SC_SIZE, MF_BYCOMMAND
  
  On Error Resume Next        'disable error handling
    Kill "COMports.log"
  On Error GoTo 0             'enable error handling
  numPorts = GetAvailablePorts("")
  ReDim cports(1 To numPorts)
  CountCOMPorts = 0
  
' Enumerate ports, eliminate duplicates, non-COM & infrared
  For n = 0 To numPorts - 1
    If Command$ = "ports" Then
      'write raw data to file
      Open "COMports.log" For Append As #1
        Print #1, comPorts(n).pPortName, comPorts(n).pDescription, Val(Mid$(comPorts(n).pPortName, 4)), comPorts(n).fPortType
      Close #1
    End If
    'filter out undesirables
    If InStr(strPorts, comPorts(n).pPortName) = 0 _
       And Left$(comPorts(n).pPortName, 3) = "COM" _
       And InStr(comPorts(n).pDescription, " Port") > 0 _
       And InStr(comPorts(n).pDescription, "Infrared") = 0 Then
      cports(Val(Mid$(comPorts(n).pPortName, 4))) = comPorts(n).pPortName
      strPorts = strPorts & comPorts(n).pPortName
      nports = nports + 1
    End If
  Next
  
  'add available ports to menu
  i = 0
  For n = 1 To numPorts
    If Mid$(cports(n), 1, 3) = "COM" Then
      On Error Resume Next
        OpenCOMPort Mid$(cports(n), 4)
        If Err.Number = 0 Then
          AddCOMPort cports(n)
          mscomm1.PortOpen = False
         i = i + 1
        End If
      On Error GoTo 0
    End If
  Next
  cntports = i
 
  n = CInt(GetSetting(appname:="enumerate", section:="cfg", Key:="port", Default:="0"))
  On Error Resume Next
    OpenCOMPort n
  On Error GoTo 0
      
  loading = False
  
End Sub

Private Sub AddCOMPort(COMPort As String)
  
  If mlngCountCOMPorts Then
    Load mnuCOMPort(mlngCountCOMPorts)
  End If

  mnuCOMPort(mlngCountCOMPorts).Caption = COMPort
  mnuCOMPort(mlngCountCOMPorts).Visible = True

  CountCOMPorts = mlngCountCOMPorts + 1
  
End Sub

Public Sub CenterForm(Optional frmParent)

  If Forms.Count = 0 Then Exit Sub
  If IsMissing(frmParent) Or Not TypeOf frmParent Is Form Then
    Forms(Forms.Count - 1).Move (Screen.Width - Forms(Forms.Count - 1).Width) / 2, (Screen.Height - Forms(Forms.Count - 1).Height) / 2
  Else
    Forms(Forms.Count - 1).Move (frmParent.Width - Forms(Forms.Count - 1).Width) / 2, (frmParent.Height - Forms(Forms.Count - 1).Height) / 2
  End If
  
End Sub

Private Function GetAvailablePorts(ServerName As String) As Long

  Dim ret As Long
  Dim PortsStruct(0 To 100) As API_PORT_INFO_2
  Dim pcbNeeded As Long
  Dim pcReturned As Long
  Dim TempBuff As Long
  Dim i As Integer

  'Get the amount of bytes needed to contain the data returned by the API call
  ret = EnumPorts(ServerName, 2, TempBuff, 0, pcbNeeded, pcReturned)
  'Allocate the Buffer
  TempBuff = HeapAlloc(GetProcessHeap(), 0, pcbNeeded)
  ret = EnumPorts(ServerName, 2, TempBuff, pcbNeeded, pcbNeeded, pcReturned)
  If ret Then
    'Convert the returned String Pointer Values to VB String Type
    CopyMem PortsStruct(0), ByVal TempBuff, pcbNeeded
    For i = 0 To pcReturned - 1
      comPorts(i).pDescription = Ptr2Str(PortsStruct(i).pDescription)
      comPorts(i).pPortName = Ptr2Str(PortsStruct(i).pPortName)
      comPorts(i).pMonitorName = Ptr2Str(PortsStruct(i).pMonitorName)
      comPorts(i).fPortType = PortsStruct(i).fPortType
    Next
  End If
  GetAvailablePorts = pcReturned
  'Free the Heap Space allocated for the Buffer
  If TempBuff Then
    HeapFree GetProcessHeap(), 0, TempBuff
  End If

End Function
Public Function Ptr2Str(ByVal lngPointer As Long) As String

  Dim temp             As String
  Dim buffer(1 To 255) As Byte
  Dim i                As Integer
  
  CopyMem buffer(1), ByVal lngPointer, 255
  temp = StrConv(buffer, vbUnicode)
  temp = Left$(temp, InStr(1, temp, Chr(0)) - 1)
  i = InStr(temp, ":")
  If i > 0 Then
    temp = Left$(temp, i - 1)
  End If
  Ptr2Str = temp

End Function
Public Sub CloseCOMPort()

   Dim i           As Integer
   
   i = CInt(GetSetting(appname:="roZetta", section:="cfg", Key:="port", Default:="0"))
   If i > 0 And mscomm1.PortOpen Then
     mscomm1.PortOpen = False
   End If
   For i = 0 To cntports - 1
     mnuCOMPort(i).Checked = False
   Next
   
End Sub
Public Property Let CountCOMPorts(ByVal NewVal As Long)
  
  Dim lngPort    As Long
  Dim lngMinPort As Long

  If NewVal = 0 Then
    lngMinPort = 1
  Else
    lngMinPort = NewVal
  End If

  For lngPort = (mlngCountCOMPorts - 1) To lngMinPort Step -1
    Unload mnuCOMPort(lngPort)
  Next

  mlngCountCOMPorts = NewVal

  If mlngCountCOMPorts = 0 Then
    mnuCOMPort(0).Caption = "None"
  End If
  
End Property
Public Sub OpenCOMPort(ByVal n As Integer)

  Dim i          As Integer
  
  If n > 0 Then
    mscomm1.CommPort = n
    mscomm1.Settings = "19200,N,8,1"
    If Not loading Then SaveSetting "enumerate", "cfg", "port", n
    If Not mscomm1.PortOpen Then
      mscomm1.PortOpen = True
    End If
    For i = 0 To cntports - 1
      If mnuCOMPort(i).Caption = "COM" & CStr(n) Then
        mnuCOMPort(i).Checked = True
        Text1.Text = Text1.Text & "COM" & CStr(n) & " Open" & vbCrLf
        Text1.SelStart = Len(Text1.Text)
      End If
    Next
  End If
  
End Sub


Private Sub Form_Unload(Cancel As Integer)

  Dim Frm As Form
  
  For Each Frm In Forms
    If Frm.Name <> Me.Name Then
      Unload Frm
      Set Frm = Nothing
    End If
  Next Frm
  
  Set enumerate = Nothing
  
End Sub




Private Sub mnuCOMPort_Click(Index As Integer)
   
  Dim i             As Integer
   
  CloseCOMPort

  i = Val(Mid$(mnuCOMPort(Index).Caption, 4))
  On Error Resume Next
    OpenCOMPort i
  On Error GoTo 0

  mnuCOMPort(Index).Checked = True
   
End Sub







Public Function Parse(ByVal list As String, ByVal separator As String, n As Integer) As String

  Dim sep      As Integer
  Dim ndx      As Integer
  
  On Local Error Resume Next
  
  Do
    ndx = ndx + 1
    sep = InStr(list, separator)
    If sep Then
      If n = ndx Then
        Parse = Left$(list, sep - 1)
        Exit Function
      End If
      list = Mid$(list, sep + Len(separator))
    Else
      If n = ndx Then
        Parse = list
      Else
        Parse = ""
      End If
      Exit Function
    End If
  Loop
  
End Function



